// Gamelan MORSE SEQUENCER DESIGNED BY DR. EMIT SNAKE-BEINGS WWW.SNAKEBEINGS.ORG
// PORT CHALMERS ARTSCIENCE RESIDENCY MARCH 2018

#include <MozziGuts.h>
#include <Oscil.h> // oscillator 
#include <tables/cos2048_int8.h> // table for Oscils to play
#include <AutoMap.h> // maps unpredictable inputs to a range

// desired carrier frequency max and min, for AutoMap
const int MIN_CARRIER_FREQ = 1220;
const int MAX_CARRIER_FREQ = 200;

// desired intensity max and min, for AutoMap, note they're inverted for reverse dynamics
const int MIN_INTENSITY = 700;
const int MAX_INTENSITY = 10;
#define STOP_PIN 11

boolean pause_triggered, paused = false;;
unsigned int count = 0;

AutoMap kMapCarrierFreq(0, 1023, MIN_CARRIER_FREQ, MAX_CARRIER_FREQ);
AutoMap kMapIntensity(0, 1023, MIN_INTENSITY, MAX_INTENSITY);
float carrier_freq = 333; //oscillator frequency
float carrier_freq2 = 333; //frequency after octave button
const int pitch_PIN = 1; // set the input for the knob to analog pin 0
const int mod_PIN = 0; // set the input for the LDR to analog pin 1

Oscil<COS2048_NUM_CELLS, AUDIO_RATE> aCarrier(COS2048_DATA);
Oscil<COS2048_NUM_CELLS, AUDIO_RATE> aModulator(COS2048_DATA);

int mod_ratio = 3; // harmonics
long fm_intensity; // carries control info from updateControl() to updateAudio()


///////////////////////////
///for recording the morsecode
//>>>>>>>>>>>>GLOBAL VARIABLES: TIMINGS, GAPS AND MIDI DATA ARRAYS
unsigned long OnTime[100]; //= {0,  0, 0,  0,  0, 0,  0,  0};//records the ON times
//unsigned long OffTime[10];// = {0,  0, 0,  0,  0, 0,  0,  0};//records the ON times
//unsigned long GapStart[10]; //= {0,  0, 0,  0,  0, 0,  0,  0};//records the gaps
//unsigned long GapEnd[10]; //= {0,  0, 0,  0,  0, 0,  0,  0};//records the gaps
int sequenceLoop = 0;
unsigned long currentMillis;
unsigned long previousMillis;
unsigned Keyon = "no";//LATCHES THE MORSE KEY FOR RECORDING MILLISECONDS
unsigned StartSeq = "no"; //this signals the first on button to prevent off state recording gap data

//////////////////
float gamTone = 0;



float gamArray[8] {204.40, 408.81, 433.51, 597.81, 648.19, 820.33, 872.61, 1198.57};
//int gamArray[10]{204.40, 408.81, 433.51, 597.81, 648.19, 820.33,872.61,1198.57};


int Soundpin = 9;
int timing = 47;//length of note

int testA0 = analogRead(A0);
int testA1 = analogRead(A1);
int testA2 = analogRead(A2);
int testA3 = analogRead(A3);
int testA4 = analogRead(A4);
int testA5 = analogRead(A5);
//BUTTONS NEXT WHEN NEEDED
//int testD4 = digitalRead(4);
char killswitchD4 = LOW;//digitalRead(4)
int volumeCont = 0; //volume control
char MorseswitchD10 = LOW; //int testD10 = digitalRead(10);
//buttons
char octaveD5 = LOW;//digitalRead(5)
int testD9 = digitalRead(9);

int testD11 = digitalRead(11);

int gammaSwitchD12 = digitalRead(12);
//int testD12 = digitalRead(12);



void setup() {

  pinMode(STOP_PIN, INPUT);
  Serial.begin(115200); // set up the Serial output so we can look at the piezo values // set up the Serial output for debugging
  startMozzi(); //
  Serial.print("we have started setup ");
}




//////////////////////////////////////////////








void updateControl() {
  if (digitalRead(STOP_PIN) == HIGH) {
    pause_triggered = true;
    count = 0;
    Serial.print("we have stopped  = ");

  }


  killswitchD4 = digitalRead(4);
  MorseswitchD10 = digitalRead(10);
  if (killswitchD4 == HIGH) {
    if (MorseswitchD10 == HIGH) {
      volumeCont = 0;
    }
    if (MorseswitchD10 == LOW) {
      volumeCont = 1;
    }

  }//end if

  if (killswitchD4 == LOW) {
    volumeCont = 1;
  }

  // read the knob
  int pitch_value = mozziAnalogRead(pitch_PIN); // value is 0-1023

  gammaSwitchD12 = digitalRead(12);
  if (gammaSwitchD12 == HIGH) {
    int pitch_value2 = map(pitch_value, 1111, 0, 0, 7); //gamescale sellector
    //gamarray pitches
    carrier_freq = gamArray[pitch_value2];
  }

  if (gammaSwitchD12 == LOW) {
    // map the knob to carrier frequency
    carrier_freq = kMapCarrierFreq(pitch_value);
  }


//carrier_freq = carrier_freq * volumeCont; //get rid of noise when no key

  //calculate the modulation frequency to stay in ratio
  int mod_freq = carrier_freq * mod_ratio;

//mod_freq = mod_freq * volumeCont; //get rid of noise when no key

  //OCTAVE SWITCH D5
  // octaveD5 = digitalRead(5);
  octaveD5 = digitalRead(5);
  if (octaveD5 == LOW) {
    // set the FM oscillator frequencies to the calculated values
    //VOLUME FOR THE KILL SWITCH - CUT THE FREQUENCY TO ZERO
    carrier_freq2 = carrier_freq / 2;
    aCarrier.setFreq((carrier_freq2)* volumeCont);
  }


  //OCTAVE SWITCH D5
  if (octaveD5 == HIGH) {
    // set the FM oscillator frequencies to the calculated values
    carrier_freq2 = carrier_freq * volumeCont;
    aCarrier.setFreq((carrier_freq2)* volumeCont);
  }

  // set the FM oscillator frequencies to the calculated values
  // aCarrier.setFreq(carrier_freq);




  aModulator.setFreq(mod_freq);

  // read the light dependent resistor on the Analog input pin
  int mod_level = mozziAnalogRead(mod_PIN); // value is 0-1023

  // print the value to the Serial monitor for debugging

  Serial.print("carrier_freq2  = ");
  Serial.print(carrier_freq2 );
  Serial.print("\t"); // prints a tab

mod_freq = mod_freq * volumeCont; //get rid of noise when no key
  Serial.print("mod_freq = ");
  Serial.print(mod_freq);
  Serial.print("\t"); // prints a tab

  fm_intensity = kMapIntensity(mod_level);

  Serial.print("fm_intensity = ");
  Serial.print(fm_intensity);
    Serial.print("\t"); // prints a tab
}


int updateAudio() {
  long modulation = (fm_intensity * aModulator.next()) * volumeCont;
  return aCarrier.phMod(modulation); // phMod does the FM

  Serial.print("modulation = ");
  Serial.print(modulation);
  Serial.println();

}























//////////////////////////////////
void loop() {




      audioHook();
  

}











