//DotMatrix library  library
#include "LedControl.h"

 //(din,clk,cs load,number of displays)
LedControl lc=LedControl(10,12,11,1);

//next for the scan dot
byte a[8]={B10000000,B01000000,B00100000,B00010000,B00001000,B00000100,B00000010,B00000001};
  
unsigned int RowProgress =0; //progress down display
unsigned int ColProgress =0; //progress down display

int stepA0 = analogRead(A0); 
int tempoA1 = analogRead(A1); 
int modeA2 = analogRead(A2); 
 
//BUTTONS NEXT WHEN NEEDED
int readD2 = digitalRead(2); //the six switches D2-D7
int readD3 = digitalRead(3);
int readD4 = digitalRead(4);
int readD5 = digitalRead(5);
int readD6 = digitalRead(6);
int readD7 = digitalRead(7);

int playPauseD8 = digitalRead(8);
int writeplayD9 = digitalRead(9);
int morseA7 = digitalRead(A7);
////

// Generally, you should use "unsigned long" for variables that hold time
// The value will quickly become too large for an int to store
unsigned long previousMillis = 0;        // will store last time snakeDelay was updated

unsigned long previousMillis2 = 0;      

int pulseOn = 1;//creates pulses from the timer
int latch = 0; // a debouncer basically
//wait a gap while turning light off
int pulseOnX4 = 0;

int scanCol = 0;// 0-7 counter for matrix
int scanRow = 0; //counter for 2nd digit 8,16,24,32,40,48,56,64.
int decimalCount =0; //single counter attempt to replace the two above
int stepA0DEC =0; //used for above decimalCount

void setup() {
  // put your setup code here, to run once:
  // initialize serial communication:
Serial.begin(9600);
  
  lc.shutdown(0,false);
  /* Set the brightness to a medium values */
  lc.setIntensity(0,9);
  /* and clear the display */
  lc.clearDisplay(0);
}/////////////////END SETUP


////////FUNCTIONS


void NoteDuration(){
//USE THIS TO RECORD THE DURATIONS OF NOTES DOT OR DASH
unsigned long duration;
 duration = pulseInLong(8, HIGH);
 Serial.print("\t  duration = ");
Serial.print(duration);
}/////////end note duration


void DotMatrixNumber(int reading) {

//the new numbers
unsigned char numbers[10][8] = {
{  B00011100,  B00100010,  B00100010,  B00100010,  B00100010,  B00100010,  B00100010,  B00011100}, //0
{  B00001000, B00011000,  B00001000,  B00001000,  B00001000,  B00001000,  B00001000,  B00011100},//1
  {  B00011100,  B00100010,  B00000010,  B00000010,  B00000100,  B00001000,  B00010000,  B00111110},//2
  {  B00011100,  B00100010,  B00000010,  B00001100,  B00000010,  B00000010,  B00100010,  B00011100},//3
  {  B00000010,  B00000110,  B00001010,  B00010010,  B00100010,  B00111110,  B00000010,  B00000010},//4
  {  B00111110,  B00100000,  B00100000,  B00111100,  B00000010,  B00000010,  B00100010,  B00011100},//5
  {  B00011100,  B00100010,  B00100000,  B00111100,  B00100010,  B00100010,  B00100010,  B00011100},//6
  {  B00111110,  B00000010,  B00000010,  B00000100,  B00001000,  B00010000,  B00010000,  B00010000},//7
{  B00011100,  B00100010,  B00100010,  B00011100,  B00100010,  B00100010,  B00100010,  B00011100},//8
{  B00011100,  B00100010,  B00100010,  B00100010,  B00011110,  B00000010,  B00100010,  B00011100}//9
};


  
 //this loop writes the int reading number
  for(int i=0;i<8;i++)
   { lc.setRow(0,i,numbers[reading][i]);
 //lc.setRow(0,7,a[7]);
   }
}//end number print


///////////////////
void ReadSensors(){
 stepA0 = analogRead(A0); 
 tempoA1 = analogRead(A1); 
 modeA2 = analogRead(A2); 
 
//BUTTONS NEXT WHEN NEEDED
 readD2 = digitalRead(2); //the six switches D2-D7
 readD3 = digitalRead(3);
 readD4 = digitalRead(4);
 readD5 = digitalRead(5);
 readD6 = digitalRead(6);
 readD7 = digitalRead(7);

playPauseD8 = digitalRead(8);
writeplayD9 = digitalRead(9);
pinMode(A7, INPUT);
pinMode(A7, INPUT_PULLUP);
morseA7 = digitalRead(A7);

//MAPPING for sensors
stepA0 = map(stepA0,1023, 50, 1, 8);//step
 int tempDecMap = analogRead(A0); 
stepA0DEC = map(tempDecMap,1023, 50, 0, 64);//step
stepA0DEC = constrain(stepA0DEC, 0, 64);
tempoA1 = map(tempoA1,1023, 0, 2000, 20);//tempo
modeA2 = map(modeA2,1023, 50, 0, 9);//mode

}//end read sensors

//TIMER THAT SETS THE TEMPO
void tempoPulse(int period){
  unsigned long currentMillis = millis();

  if (currentMillis - previousMillis >= period) {
    // save the last time pulseOn was 1
    previousMillis = currentMillis;
   
   // if the pulse is 0 (off) turn it to 1 (on) and vice-versa:
    if (pulseOn == 0) {
      pulseOn = 1;
    } else {
     //SETS THE PULSE ON FOR DISCOVERY ELSEWHERE 
      pulseOn = 0;
    }  
  }
}//>END TIMER tempoPulse

//4x faster TIMER THAT records variables in timing speed
void tempoPulseX4(int period){
  unsigned long currentMillis2 = millis();

  if (currentMillis2 - previousMillis2 >= (period/4)) {
    // save the last time pulseOn was 1
    previousMillis2 = currentMillis2;
   
   // if the pulse is 0 (off) turn it to 1 (on) and vice-versa:
    if (pulseOnX4 == 0) {
      pulseOnX4 = 1;
    } else {
     //SETS THE PULSE ON X4 speed FOR DISCOVERY ELSEWHERE 
      pulseOnX4 = 0;
    }  
  }
}//>END TIMER tempoPulse



//>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
void loop() {

  
int stepChanged = stepA0;
int modeChanged = modeA2;
ReadSensors();
tempoPulse(tempoA1);


//test for recording duration of morse key (using red key for now)
if(playPauseD8 == 1){
  //calls a funtion
  NoteDuration();
}


//see if step setting has changed-just for display
if(stepChanged != stepA0)
{//call the numbers up to show step setting
  DotMatrixNumber(stepA0);
  }

if(modeChanged != modeA2)
{//call the numbers up to show mode setting
  DotMatrixNumber(modeA2);}



//clear the display between dot scans
if(pulseOn == 0 and latch == 1){
 
  //only clear display if on scandot mode
  //if(writeplayD9 == 1){
    lc.clearDisplay(0);///}
    latch = 0;}
 
if(pulseOn == 1 and latch == 0){
if(writeplayD9 == 0){
DotMatrixNumber(stepA0);
}else{
 lc.setRow(0,scanRow,a[scanCol]); ;
}
latch = 1;//stop multiple click-debouncer
//advance the scan position for the dotmatrix 8x8 display
scanCol++;
//set the decimalCount going for array management - need to translate this into scanning the matrix
//rather than use the scanCol and scanRow ints 
decimalCount++;
if(decimalCount >= stepA0DEC){decimalCount =0;}
Serial.print("\t stepA0DEC = ");
Serial.print(stepA0DEC);
Serial.print("\t decimalCount = ");
Serial.print(decimalCount);
Serial.print("\t morseA7 = ");
Serial.print(morseA7);
Serial.println(">>>");
//USING THE stepA0 CONTROL TO LIMIT THE SCAN
   if(scanCol >= stepA0){scanCol = 0; scanRow++;}
    if(scanRow >= stepA0){scanRow = 0;}
}




}//END LOOP



